package com.ruoyi.bst.agreement.service;

import java.util.List;

import com.ruoyi.bst.agreement.domain.Agreement;
import com.ruoyi.bst.agreement.domain.AgreementQuery;
import com.ruoyi.bst.agreement.domain.AgreementVO;
import com.ruoyi.bst.agreement.domain.enums.AgreementType;

/**
 * 协议Service接口
 *
 * @author ruoyi
 * @date 2025-04-07
 */
public interface AgreementService
{
    /**
     * 查询协议
     *
     * @param id 协议主键
     * @return 协议
     */
    public AgreementVO selectAgreementById(Long id);

    /**
     * 查询协议列表
     *
     * @param agreement 协议
     * @return 协议集合
     */
    public List<AgreementVO> selectAgreementList(AgreementQuery agreement);

    /**
     * 新增协议
     *
     * @param agreement 协议
     * @return 结果
     */
    public int insertAgreement(Agreement agreement);

    /**
     * 修改协议
     *
     * @param agreement 协议
     * @return 结果
     */
    public int updateAgreement(Agreement agreement);

    /**
     * 批量删除协议
     *
     * @param ids 需要删除的协议主键集合
     * @return 结果
     */
    public int deleteAgreementByIds(List<Long> ids);

    /**
     * 删除协议信息
     *
     * @param id 协议主键
     * @return 结果
     */
    public int deleteAgreementById(Long id);

    /**
     * 复制模板
     * @param type
     * @param areaId
     * @return
     */
    public int copyTemplate(AgreementType type, Long areaId);

}
